/// @description Player Logic

// get input
if (controls) {
if (!dashMode) {
	if (keyboard_check(left)) {
		if (!keyboard_check(right)) {
			if (hSp > -baseSpeed) {
				hSp -= baseAcceleration;
			} else {
				hSp = -baseSpeed;
			}
		}
	}
	
	if (keyboard_check(right)) {
		if (!keyboard_check(left)) {
			if (hSp < baseSpeed) {
				hSp += baseAcceleration;
			} else {
				hSp = baseSpeed;
			}
		}
	}
	
	if ((keyboard_check(left) && keyboard_check(right)) || (!keyboard_check(left) && !keyboard_check(right))) {
		hSp /= baseFriction;
	}
} else {
	hSp /= dashFriction;
	if (abs(hSp) < 5) {
		dashMode = 0;
		if (place_meeting(x, y + 1, obj_wall)) {
			hasDash = 1;
		}
	}
}

// jumping
if (keyboard_check_pressed(jump)) {
	if (hasJump) {
		if (onGround) {
			audio_play_sound(snd_jump, 1, 0);
			vSp = jumpForce;
		} else {
			if (hasDoubleJump) {
				if (!doubleJumped) {
					doubleJumped = 1;
					audio_play_sound(snd_jump, 1, 0);
					vSp = jumpForce;
				}
			}
		}
	}
}

// precise jumping
if (!keyboard_check(jump)) {
	if (!onGround) {
		if (vSp < 0) {
			if (!springJump) {
				vSp /= jumpModifier;
			}
		}
	}
}

// dash
if (keyboard_check_pressed(dash)) {
	if (dashEnabled) {
		if (hasDash) {
			if (!dashMode) {
				dashMode = 1;
				hasDash = 0;
				var dashMod;
				dashMod = 1;
				if (keyboard_check(right)) {
					dashMod = 1;
				}
				if (keyboard_check(left)) {
					dashMod = -1;
				}
				var dashLength = 0;
				while (!place_meeting(x + dashLength, y, obj_wall)) {
					dashLength += dashMod;
					if (abs(dashLength) >= abs(dashForce)) {
						break;
					}
				}
				hSp = dashLength;
				vSp = -2;
				
				audio_play_sound(snd_dash, 1, 0);
				
				springJump = 0;
			}
		}
	}
}
}	// END IF CONTROLS

// gravity setup
if (!place_meeting(x, y + 1, obj_wall)) {
	onGround = 0;
	currentGravity = baseGravity;
}

// gravity handling
vSp += currentGravity;
if (vSp > maxVSp) {
	vSp = maxVSp;
}

// dash block collision
if (place_meeting(x + hSp, y, obj_breakableWall)) {
	if (dashMode) {
		var block = instance_nearest(x + hSp, y, obj_breakableWall);
		with (block) {
			var placeholder = instance_create_layer(x, y, "Instances", obj_breakableWallPlaceholder);
			placeholder.savedSizeX = image_xscale;
			placeholder.savedSizeY = image_yscale;

			instance_destroy();
		}
	}
}

// wall collision
if (place_meeting(x + hSp, y, obj_wall)) {
	if (hSp > 0) {
		move_contact_all(0, hSp);
	}
	if (hSp < 0) {
		move_contact_all(180, abs(hSp));
	}
	
	hSp = 0;
}

if (place_meeting(x, y + vSp, obj_wall)) {
	if (vSp > 0) {
		move_contact_all(270, vSp);
		currentGravity = 0;
		onGround = 1;
		doubleJumped = 0;
		dashMode = 0;
		hasDash = 1;
		springJump = 0;
	}
	if (vSp < 0) {
		move_contact_all(90, abs(vSp));
	}
	
	vSp = 0;
}

// destroy texts if necessary
if (global.textSpawned) {
	if (!place_meeting(x, y, obj_floatText)) {
		global.textSpawned = 0;
		obj_textDisplay.fadeOut = 1;
	}
}

// character animation
currentRot += hSp * rotSpeed;

sineFloat += sineSpeed;
if (sineFloat > 6.28) {
	sineFloat -= 6.28;
}

// cam override
if (place_meeting(x, y, obj_camOverride)) {
	var camController = instance_nearest(x, y, obj_camOverride);
	obj_camera.camTarget = camController.target;
	obj_camera.camSmoothness = camController.smoothness;
} else {
	obj_camera.camTarget = obj_camera.origTarget;
	obj_camera.camSmoothness = obj_camera.origSmoothness;
}

// DEATH ZONE
// OOB
if (x > room_width + OOBm || x < -OOBm || y > room_height + OOBm || y < -OOBm) {
	instance_destroy();
}

// move the character
if (controls) {
	x += hSp;
	y += vSp;
} else {
	hSp = 0;
	vSp = 0;
}